<?php
/**
* Helper class for daylife module
* @version		1.0
* @package		mod_daylife
* @copyright	Copyright (C) 2008 - 2009 SoftForge Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* mod_daylife is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

# Configure the daylife api server url  
class modDaylifeHelper
{
    /**
     * Retrieves the daylife feeds 
     *
     * @param array $params An object containing the module parameters
     * @access public
     */    
    function getDaylife( $params ) {
	
		function neat_trim($str, $n, $delim) {
		
			$len = strlen($str);
   
			if ($len > $n) {
				preg_match('/(.{' . $n . '}.*?)\b/', $str, $matches);
				$str = rtrim($matches[1]) . $delim;
				$article['headline'] = $str;
		
				return $article['headline'];				
			} else {
			$article['headline'] = $str;
				return $article['headline'];
			}
		}

		$server_address	= $params->get('server_address', '');
		$access = $params->get('access', '');
		$protocol = $params->get('protocol', '');	
		$version = $params->get('version', '');		
		$access_url = "http://" . $server_address . "/" . $protocol . "/" . $access . "/" . $version . "/";
		$method='search_getRelatedArticles';

		# Configure your api credentials 

		$accesskey	= $params->get('accesskey', '');
		$sharedsecret	= $params->get('sharedsecret', '');

		# specify your query

		$query	= $params->get('query', '');
		$url_encoded_query = urlencode($query);

		# For search_X methods, the Core Input is the query term itself
		$signature = md5($accesskey . $sharedsecret . $query);
		$limit	= $params->get('limit', '');
		$offset	= $params->get('offset', '');
		$sort	= $params->get('sort', '');
		$end_time	= $params->get('end_time', '');
		$start_time	= $params->get('start_time', '');

		$days_from_now	= $params->get('days_from_now', '');
		$source_filter_id	= $params->get('source_filter_id', '');
		$include_scores	= $params->get('include_scores', '');

		if ($days_from_now !="") {
			$days_from_now = intval($days_from_now);
			if ($days_from_now=="0") {
				$days_from_now ="";
			}
		}
		
		if ($days_from_now!=""&& $end_time!="") {
			$start_time = strtotime($end_time) - ($days_from_now * 86400);
		}
		
		if ($days_from_now!=""&& $end_time=="") {

			$start_time = time() - ($days_from_now * 86400);
		}
	
		$include_date = $params->get('include_date', '');
		$show_date_on = $params->get('show_date_on', '');
		$include_source	= $params->get('include_source', '');
		$show_source_on	= $params->get('show_source_on', '');
		$spacer_date = $params->get('spacer_date', '');
		$spacer_source = $params->get('spacer_source', '');
		$footer = $params->get('footer', '');
		$show_footer = $params->get('show_footer', '');
		$add_padding = $params->get('add_padding', '');
		$include_target = $params->get('include_target', '');
		$title_length = $params->get('title_length', '');
		$title_truncator = $params->get('title_truncator', '');
		$style_type = $params->get('style_type', '');
		$daylife_url_styling = $params->get('daylife_url_styling', '');
		$daylife_time_styling = $params->get('daylife_time_styling', '');
		$show_daylife_badge = $params->get('show_daylife_badge', '');	
		$composed_url = $access_url . $method . '?accesskey=' . $accesskey . '&signature=' . $signature . '&query=' . $url_encoded_query . '&end_time=' . $end_time . '&start_time=' . $start_time . '&limit=' . $limit . '&offset=' . $offset . '&sort=' . $sort . '&source_filter_id=' . $source_filter_id . '&include_scores=' . $include_scores;
		# kick off the call
		$result = file_get_contents($composed_url);
		$relatedArticlesResponse = unserialize($result);
		$relatedArticles = $relatedArticlesResponse['response']['payload']['article'];
		$articleListing ='';

		if($style_type=="list") {
			$articleListing .='<ul>';
		}
		
		if($daylife_url_styling == "none") {
			$daylife_url_styling = 'font-weight:normal';
		}
		
		if($daylife_url_styling == "bold") {
			$daylife_url_styling = 'font-weight:bold';
		}
		
		if($daylife_url_styling == "italic") {
			$daylife_url_styling = 'font-style:italic';
		}
		
		if($daylife_url_styling == "both") {
			$daylife_url_styling = 'font-weight:bold;font-style:italic';
		}
		
		if($daylife_time_styling == "none") {
			$daylife_time_styling = 'font-weight:normal';
		}
		
		if($daylife_time_styling == "bold") {
			$daylife_time_styling = 'font-weight:bold';
		}
		
		if($daylife_time_styling == "italic") {
			$daylife_time_styling = 'font-style:italic';
		}
		
		if($daylife_time_styling == "both") {
			$daylife_time_styling = 'font-weight:bold;font-style:italic';
		}
		
		if($daylife_source_styling == "none") {
			$daylife_source_styling = 'font-weight:normal';
		}
		
		if($daylife_source_styling == "bold") {
			$daylife_source_styling = 'font-weight:bold';
		}
		
		if($daylife_source_styling == "italic") {
			$daylife_source_styling = 'font-style:italic';
		}
		
		if($daylife_source_styling == "both") {
			$daylife_source_styling = 'font-weight:bold;font-style:italic';
		}	

		foreach ($relatedArticles as $article) {
			$source = $article['source'];
			$scores = $article['scores'];
	
			if($add_padding != "") {
		
				if($style_type=="list") {
					$articleListing .= "<li style=\"padding-bottom:" . $add_padding . "px\">";
				}
		
				if($style_type=="div") {
					$articleListing .= "<div class=\"daylife\" style=\"padding-bottom:" . $add_padding . "px\">";
				}
	
				if($style_type=="para") {
					$articleListing .= "<p class=\"daylife\" style=\"padding-bottom:" . $add_padding . "px\">";
				}
				
			} else {
	
				if($style_type=="list") {
					$articleListing .= "<li>";
				}

				if($style_type=="div") {
					$articleListing .= "<div class=\"daylife\">";
				}	
		
				if($style_type=="para") {
					$articleListing .= "<p class=\"daylife\">";
				}
			}
	
			$articleListing .= "<span class=\"daylife_url\" style=\"". $daylife_url_styling . "\"><a href=" . $article['url'] ." " . $include_target . ">" ;
	
			if ($title_length !="") {
			
				$delim = $title_truncator;
				$n = $title_length;
				$str = $article['headline'];
				$article['headline'] = neat_trim($str,$n,$delim);
				$article['headline'] = str_replace('\"','"',$article['headline']);
			}
	
			$article['headline'] = str_replace('\"','"',$article['headline']);
			$articleListing .= $article['headline'] . '</a></span>';

			if($include_date == "yes") {
			$articleListing .= "$spacer_date <span class=\"daylife_time\" style=\"". $daylife_time_styling . "\">" . $article['timestamp'] . "</span>";
			}
	
			if($include_date == "different") {
				$articleListing .= "<br/>";	
				$articleListing .= " <span class=\"daylife_time\" style=\"". $daylife_time_styling . "\">" . $article['timestamp'] . "</span>";
			}
		
			if($include_source == "yes") {
				$articleListing .= "$spacer_source " . " <span class=\"daylife_source\" style=\"". $daylife_source_styling . "\"><a href=" .$source['url'] ." " . $include_target . ">" . $source['name'] . "</a></span> " ;
			}
			if($include_source == "different") {
				$articleListing .= "<br/>from the <span class=\"daylife_source\" style=\"". $daylife_source_styling . "\"><a href=" .$source['url'] ." " . $include_target . ">" . $source['name'] . "</a></span> ";
			}
		
			if($scores['newsdomain']) {
				$articleListing .= " score newsdomain ".$scores['newsdomain'];
			}
	
			if($scores['op-ed']) {
				$articleListing .= " op-ed " . $scores['op-ed'];
			}
	
			if($scores['spinometer']) {
				$articleListing .= " spinometer " . $scores['spinometer'];
			}

			if($style_type=="list") {
				$articleListing .= "</li> " ;
			}
			
			if($style_type=="para") {
				$articleListing .= "</p>";
			}

			if($style_type=="div") {
				$articleListing .= "</div>";
			}
		}

		if($style_type=="list") {
				$articleListing .= "</ul>";
		}
		if($show_footer=="yes") {
				$articleListing .= "<div class=\"dl_footer\">" . $footer . "</div>";
		}

		if($show_daylife_badge=="white") {
				$articleListing .= "<div class=\"daylife_badge\"><a href=\"http://www.daylife.com\" title=\"Daylife Badge\" target=\"_blank\">
				<img alt=\"Daylife Badge\" src=\"/modules/mod_daylife/images/DLpbWHThoriz.png\"/>
				</a></div>";
		}
		if($show_daylife_badge=="black") {
				$articleListing .= "<div class=\"daylife_badge\"><a href=\"http://www.daylife.com\" title=\"Daylife Badge\" target=\"_blank\">
				<img alt=\"Daylife Badge\" src=\"/modules/mod_daylife/images/DLpbBLKhoriz.png\"/>
				</a></div>";
		}
		
		return "  {$articleListing} ";
    }
}
?>